'use strict'

const vulns = require('../data/vulns.core.json') // freeze?

class Vulnerability {
  constructor (id) {
    this.id = id
  }

  get source () {
    return `https://github.com/nodejs/security-wg/tree/master/vuln/core/${this.id}.json`
  }

  get isValid () {
    return !!vulns[this.id]
  }
}

Object.values(vulns).reduce((p, v) => {
  return (Object.keys(v).forEach(k => { if (k !== 'id' && !p.includes(k)) p.push(k) }) || p)
}, []).forEach(getter => {
  Vulnerability.prototype.__defineGetter__(getter, function () {
    return (vulns[this.id] || {})[getter]
  })
})

module.exports = Vulnerability
